#include "WASMItemRegistry.hpp"
#include "../../../../Battling/Library/BattleLibrary.hpp"
#include "../../WebAssemblyScriptResolver.hpp"
#include "../WASMHelperFile.hpp"
#include "wasm.h"

using namespace CreatureLib::Library;

wasm_func_t* Item_HasFlagByHash(WebAssemblyScriptResolver* resolver) {
    return WasmHelpers::CreateFunc<bool, Item*, u32>(
        resolver, {[](WebAssemblyScriptResolver*, Item* item, u32 flag) -> bool { return item->HasFlag(flag); }});
}
void WASMItemRegistry::Register(ArbUt::Dictionary<std::string, wasm_func_t*>& externs,
                                WebAssemblyScriptResolver* resolver) {
    REGISTER_GETTER("item_get_name", Item, GetName, resolver)
    REGISTER_GETTER("item_get_category", Item, GetCategory, resolver)
    REGISTER_GETTER("item_get_battle_category", Item, GetBattleCategory, resolver)
    REGISTER_GETTER("item_get_price", Item, GetPrice, resolver)
    REGISTER_GETTER("item_get_fling_power", PkmnLib::Library::Item, GetFlingPower, resolver)
    externs.Insert("item_has_flag_by_hash", Item_HasFlagByHash(resolver));
}
